#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import numpy as np
import matplotlib.pyplot as plt
import json, codecs
from pathlib import Path
from scipy.optimize import curve_fit
import scipy
import glob
import os



'''
Write here the path to the folder where this script is stored 
'''
scriptpath = 'YOURPATH'


#%%
'''Figure 4a: Q1'''


reference_arrays_magnitude =np.load(scriptpath + 'a/Q1/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'a/Q1/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'a/Q1/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'a/Q1/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'a/Q1/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'a/Q1/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'a/Q1/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'a/Q1/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (10): #In this measurement a train average of 10 times the same sequence is used
    for k in range (41): #In this measurement we acquire 41 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,160,41)
averaged_data_array = np.average(data_arrays, axis = 0) # here the average is taken over the 10 traces
plt.plot(sweep_array, averaged_data_array, 'o') #this is the data plotted in the paper 
plt.xlabel('Interaction Time (ns)')
plt.ylabel('\u0394 |S21mag| (arb. un.)')
#%%
'''Figure 4a: Q2'''


reference_arrays_magnitude =np.load(scriptpath + 'a/Q2/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'a/Q2/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'a/Q2/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'a/Q2/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'a/Q2/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'a/Q2/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'a/Q2/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'a/Q2/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (10): #In this measurement a train average of 10 times the same sequence is used
    for k in range (41): #In this measurement we acquire 41 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,160,41)
averaged_data_array = np.average(data_arrays, axis = 0) # here the average is taken over the 10 traces
plt.plot(sweep_array, averaged_data_array, 'o') #this is the data plotted in the paper 
plt.xlabel('Interaction Time (ns)')
plt.ylabel('\u0394 |S21mag| (arb. un.)')
#%%
'''Figure 4b: Q1'''


reference_arrays_magnitude =np.load(scriptpath + 'b/Q1/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'b/Q1/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'b/Q1/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'b/Q1/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'b/Q1/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'b/Q1/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'b/Q1/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'b/Q1/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (10): #In this measurement a train average of 10 times the same sequence is used
    for k in range (41): #In this measurement we acquire 41 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,160,41)
averaged_data_array = np.average(data_arrays, axis = 0) # here the average is taken over the 10 traces
plt.plot(sweep_array, averaged_data_array, 'o') #this is the data plotted in the paper 
plt.xlabel('Interaction Time (ns)')
plt.ylabel('\u0394 |S21mag| (arb. un.)')

#%%
'''
Figure 4b: Q2
'''

reference_arrays_magnitude =np.load(scriptpath + 'b/Q2/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'b/Q2/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'b/Q2/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'b/Q2/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'b/Q2/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'b/Q2/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'b/Q2/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'b/Q2/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (10): #In this measurement a train average of 10 times the same sequence is used
    for k in range (41): #In this measurement we acquire 41 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,160,41)
averaged_data_array = np.average(data_arrays, axis = 0) # here the average is taken over the 10 traces
plt.plot(sweep_array, averaged_data_array, 'o') #this is the data plotted in the paper 
plt.xlabel('Interaction Time (ns)')
plt.ylabel('\u0394 |S21mag| (arb. un.)')

#%%
'''Figure 4c: Q1'''


reference_arrays_magnitude =np.load(scriptpath + 'c/Q1/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'c/Q1/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'c/Q1/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'c/Q1/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'c/Q1/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'c/Q1/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'c/Q1/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'c/Q1/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (10): #In this measurement a train average of 10 times the same sequence is used
    for k in range (31): #In this measurement we acquire 31 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,120,31)
averaged_data_array = np.average(data_arrays, axis = 0) # here the average is taken over the 10 traces
plt.plot(sweep_array, averaged_data_array, 'o') #this is the data plotted in the paper 
plt.xlabel('Interaction Time (ns)')
plt.ylabel('\u0394 |S21mag| (arb. un.)')
    
    
#%%
'''Figure 4c: Q2'''


reference_arrays_magnitude =np.load(scriptpath + 'c/Q2/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'c/Q2/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'c/Q2/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'c/Q2/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'c/Q2/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'c/Q2/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'c/Q2/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'c/Q2/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (10): #In this measurement a train average of 10 times the same sequence is used
    for k in range (31): #In this measurement we acquire 31 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,120,31)
averaged_data_array = np.average(data_arrays, axis = 0) # here the average is taken over the 10 traces
plt.plot(sweep_array, averaged_data_array, 'o') #this is the data plotted in the paper 
plt.xlabel('Interaction Time (ns)')
plt.ylabel('\u0394 |S21mag| (arb. un.)')

#%%
'''Figure 4d: Q1'''


reference_arrays_magnitude =np.load(scriptpath + 'd/Q1/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'd/Q1/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'd/Q1/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'd/Q1/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'd/Q1/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'd/Q1/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'd/Q1/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'd/Q1/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (10): #In this measurement a train average of 10 times the same sequence is used
    for k in range (31): #In this measurement we acquire 31 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,120,31)
averaged_data_array = np.average(data_arrays, axis = 0) # here the average is taken over the 10 traces
plt.plot(sweep_array, averaged_data_array, 'o') #this is the data plotted in the paper 
plt.xlabel('Interaction Time (ns)')
plt.ylabel('\u0394 |S21mag| (arb. un.)')
    
#%%
'''Figure 4d: Q2'''


reference_arrays_magnitude =np.load(scriptpath + 'd/Q2/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'd/Q2/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'd/Q2/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'd/Q2/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'd/Q2/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'd/Q2/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'd/Q2/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'd/Q2/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (10): #In this measurement a train average of 10 times the same sequence is used
    for k in range (31): #In this measurement we acquire 31 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,120,31)
averaged_data_array = np.average(data_arrays, axis = 0) # here the average is taken over the 10 traces
plt.plot(sweep_array, averaged_data_array, 'o') #this is the data plotted in the paper 
plt.xlabel('Interaction Time (ns)')
plt.ylabel('\u0394 |S21mag| (arb. un.)')
    
#%%
'''Figure 4e: Q1'''


reference_arrays_magnitude =np.load(scriptpath + 'e/Q1/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'e/Q1/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'e/Q1/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'e/Q1/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'e/Q1/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'e/Q1/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'e/Q1/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'e/Q1/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (25): #This is a 2D measurement, where the magnetic field angle is stepped with 25 points
    for k in range (41): #In this measurement we acquire 41x25 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,160,41)
angle_array =   np.arange(10, 13.75, 0.15)


fig = plt.figure()
ax = plt.axes()
x = sweep_array
y = angle_array
z = np.array(data_arrays)

plt.xlabel('Time (ns)')
plt.ylabel('Magnetic field angle \u03C6 (deg)')
# plt.xunit('mV', labelpad = 1.5)
# plt.yunit('mV', labelpad = 1.5)
plt.plot()
c=plt.pcolor(x,y,z,cmap='afmhot',vmin=z.min(), vmax=z.max()*1)

#%%
'''Figure 4f: Q2'''


reference_arrays_magnitude =np.load(scriptpath + 'f/Q2/reference_array_total_magnitude.npy')
measurement_arrays_magnitude = np.load(scriptpath + 'f/Q2/measurement_array_total_magnitude.npy')
reference_arrays_phase =np.load(scriptpath + 'f/Q2/reference_array_total_phase.npy')
measurement_arrays_phase = np.load(scriptpath + 'f/Q2/measurement_array_total_phase.npy')
reference_arrays_I =np.load(scriptpath + 'f/Q2/reference_array_total_I.npy')
measurement_arrays_I = np.load(scriptpath + 'f/Q2/measurement_array_total_I.npy')
reference_arrays_Q =np.load(scriptpath + 'f/Q2/reference_array_total_Q.npy')
measurement_arrays_Q = np.load(scriptpath + 'f/Q2/measurement_array_total_Q.npy')



'Choose which signal to use, in the paper the magnitude is used'
signal = 'magnitude'

if signal == 'magnitude': 
    reference_arrays = reference_arrays_magnitude
    measurement_arrays = measurement_arrays_magnitude
elif signal == 'phase':
    reference_arrays = reference_arrays_phase
    measurement_arrays = measurement_arrays_phase
elif signal == 'I':
    reference_arrays = reference_arrays_I
    measurement_arrays = measurement_arrays_I
elif signal == 'Q':
    reference_arrays = reference_arrays_Q
    measurement_arrays = measurement_arrays_Q
    
''''Now the reference_arrays and measurement_arrays contain all the readout traces of the reference and measurement respectively
of all plotted datapoints 
'''
data_array = []
data_arrays = []
for i in range (25): #This is a 2D measurement, where the magnetic field angle is stepped with 25 points
    for k in range (41): #In this measurement we acquire 41x25 datapoints
        difference_array_sum = [0]
        difference_array = np.abs((reference_arrays[i][k]-measurement_arrays[i][k]))
        for element in difference_array: #Here the sum is taken over the difference between the reference and measurement traces for the 12 consecutive segments
            difference_array_sum = difference_array_sum+element
        data_array.append(difference_array_sum[0])
    data_arrays.append(data_array)
    data_array = []
        
    
fig = plt.figure(figsize = (8,6))    
sweep_array = np.linspace(0,160,41)
angle_array =   np.arange(10, 13.75, 0.15)


fig = plt.figure()
ax = plt.axes()
x = sweep_array
y = angle_array
z = np.array(data_arrays)

plt.xlabel('Time (ns)')
plt.ylabel('Magnetic field angle \u03C6 (deg)')
# plt.xunit('mV', labelpad = 1.5)
# plt.yunit('mV', labelpad = 1.5)
plt.plot()
c=plt.pcolor(x,y,z,cmap='afmhot',vmin=z.min(), vmax=z.max()*1)
